---------------------------------------------------------------------------------
-- Navision Tools per Contacts
---------------------------------------------------------------------------------


SELECT im_category_new (nextval('im_categories_seq')::integer,'Atril Deja Vu','Intranet TM Tool');
SELECT im_category_new (nextval('im_categories_seq')::integer,'Trados ExtraTerm','Intranet TM Tool');
SELECT im_category_new (nextval('im_categories_seq')::integer,'Trados MultiTerm','Intranet TM Tool');
SELECT im_category_new (nextval('im_categories_seq')::integer,'Trados TagEditor','Intranet TM Tool');
SELECT im_category_new (nextval('im_categories_seq')::integer,'Trados Workbench','Intranet TM Tool');
SELECT im_category_new (nextval('im_categories_seq')::integer,'WordFast','Intranet TM Tool');
SELECT im_category_new (nextval('im_categories_seq')::integer,'Star Transit','Intranet TM Tool');



drop function nav_import_contact_tool_categories();
create or replace function nav_import_contact_tool_categories ()
returns integer as $BODY$
DECLARE
        row			RECORD;
	v_exists_p		integer;
BEGIN
    FOR row IN
	select distinct "Tools Name"
	from nav."Contact Tools"
    LOOP
	select count(*) into v_exists_p from im_categories
	where category = row."Tools Name" and category_type in ('Intranet TM Tool', 'Intranet LOC Tool');

	IF v_exists_p = 0 THEN
		PERFORM im_category_new (nextval('im_categories_seq')::integer,row."Tools Name",'Intranet LOC Tool');
	END IF;

    END LOOP;
    RETURN 0;
END;$BODY$ language 'plpgsql';
select nav_import_contact_tool_categories ();






-- Adding the tools the ]po[ Freelance Skill Database

drop function nav_import_contact_tools();
create or replace function nav_import_contact_tools ()
returns integer as $BODY$
DECLARE
        row			RECORD;
	v_user_id		integer;
	v_tool_id		integer;
	v_exists_p		integer;
	v_skill_type_id		integer;
	v_skill_type_category	varchar;
BEGIN
    FOR row IN
        select	*
	from nav."Contact Tools"
	order by "Contact No_"
    LOOP
	-- Lookup user
	select person_id into v_user_id from persons
	where nav_contact_nr ~ row."Contact No_";
	IF v_user_id is null THEN
		RAISE WARNING 'Did not find user=%', row."Contact No_";
		continue;
	END IF;

	-- Lookup Tool
	select category_id into v_tool_id from im_categories
	where category = row."Tools Name" and category_type in ('Intranet TM Tool', 'Intranet LOC Tool');
	IF v_tool_id is null THEN
		RAISE WARNING 'Did not find tool=%', row."Tools Name";
		continue;
	END IF;

	-- Determine the skill type
	select category_type into v_skill_type_category from im_categories where category_id = v_tool_id;
	select category_id into v_skill_type_id from im_categories
	where	category_type = 'Intranet Skill Type' and
		category_description = v_skill_type_category;
	IF v_skill_type_id is null THEN
		RAISE WARNING 'Did not find skill type=%, tool=%', v_skill_type_category, v_tool_id;
		continue;
	END IF;
	

	-- Check if the entry was already there
	select count(*) into v_exists_p from im_freelance_skills
	where user_id = v_user_id and skill_id = v_tool_id;
	IF v_exists_p = 0 THEN
		RAISE NOTICE 'Adding Skill: User=%, Skill=%', row."Contact No_", row."Tools Name";
		insert into im_freelance_skills (
			user_id, skill_id, skill_type_id, claimed_experience_id, confirmed_experience_id
		) values (
			v_user_id, v_tool_id, v_skill_type_id, 2203, 2203
		);
	END IF;


    END LOOP;
    RETURN 0;
END;$BODY$ language 'plpgsql';
select nav_import_contact_tools ();



